Package com.sas.metadata.remote

# Interface AbstractProperty

All Superinterfaces:
  `CMetadata`, `LocalizedType`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

All Known Subinterfaces:
  `AssociationProperty`, `AttributeProperty`, `Property`, `PrototypeProperty`

public interface AbstractProperty extends LocalizedType
Used to contain name/value pairs.

The AbstractProperty metadata type defines attributes and associations that are common to all of the property types; however, as a supertype, it should not be instantiated. When defining a metadata object to contain an actual name/value pair, use the Property metadata type or one of the other property metadata types, depending on the usage goal.

Attributes of AbstractProperty are:

- `IsVisible`
- `IsUpdateable`
- `IsExpert`
- `IsRequired`
- `IsLinked`

Associations of AbstractProperty are:

- `AssociatedPropertyGroup`
- `StoredConfiguration`
- `Customizers`
- `Editors`
- `Validators`

## Usage

To create an instance of this AbstractProperty, use the `factory` create methods.
Example: create a AbstractProperty with name "AbstractProperty_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     AbstractProperty myObject = (AbstractProperty) factory.createComplexMetadataObject(objectStore, "AbstractProperty_Object", MetadataObjects.ABSTRACTPROPERTY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ASSOCIATEDPROPERTYGROUP_NAME`
  Constant used for the name of the AssociatedPropertyGroup association.
  `static final String`
  `ASSOCIATION_CUSTOMIZERS_NAME`
  Constant used for the name of the Customizers association.
  `static final String`
  `ASSOCIATION_EDITORS_NAME`
  Constant used for the name of the Editors association.
  `static final String`
  `ASSOCIATION_STOREDCONFIGURATION_NAME`
  Constant used for the name of the StoredConfiguration association.
  `static final String`
  `ASSOCIATION_VALIDATORS_NAME`
  Constant used for the name of the Validators association.
  `static final String`
  `ATTRIBUTE_ISEXPERT_NAME`
  Constant used for the name of the IsExpert attribute.
  `static final String`
  `ATTRIBUTE_ISLINKED_NAME`
  Constant used for the name of the IsLinked attribute.
  `static final String`
  `ATTRIBUTE_ISREQUIRED_NAME`
  Constant used for the name of the IsRequired attribute.
  `static final String`
  `ATTRIBUTE_ISUPDATEABLE_NAME`
  Constant used for the name of the IsUpdateable attribute.
  `static final String`
  `ATTRIBUTE_ISVISIBLE_NAME`
  Constant used for the name of the IsVisible attribute.

  ### Fields inherited from interface com.sas.metadata.remote.LocalizedType

  `ASSOCIATION_RESOURCES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PropertyGroup`
  `getAssociatedPropertyGroup()`
  Gets the `PropertyGroup` for `AssociatedPropertyGroup`
  `AssociationList`
  `getAssociatedPropertyGroups()`
  Gets the AssociationList of `AssociatedPropertyGroups`
  `AssociationList`
  `getAssociatedPropertyGroups(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedPropertyGroups`
  `AssociationList`
  `getCustomizers()`
  Gets the Association list of `Customizers`
  `AssociationList`
  `getCustomizers(boolean fGoToServer)`
  Gets the Associationlist of `Customizers`
  `AssociationList`
  `getEditors()`
  Gets the Association list of `Editors`
  `AssociationList`
  `getEditors(boolean fGoToServer)`
  Gets the Associationlist of `Editors`
  `int`
  `getIsExpert()`
  Gets the `int` value of `IsExpert`
  `int`
  `getIsExpertState()`
  Gets the Metadata State of `IsExpert`
  `int`
  `getIsLinked()`
  Gets the `int` value of `IsLinked`
  `int`
  `getIsLinkedState()`
  Gets the Metadata State of `IsLinked`
  `int`
  `getIsRequired()`
  Gets the `int` value of `IsRequired`
  `int`
  `getIsRequiredState()`
  Gets the Metadata State of `IsRequired`
  `int`
  `getIsUpdateable()`
  Gets the `int` value of `IsUpdateable`
  `int`
  `getIsUpdateableState()`
  Gets the Metadata State of `IsUpdateable`
  `int`
  `getIsVisible()`
  Gets the `int` value of `IsVisible`
  `int`
  `getIsVisibleState()`
  Gets the Metadata State of `IsVisible`
  `Text`
  `getStoredConfiguration()`
  Gets the `Text` for `StoredConfiguration`
  `AssociationList`
  `getStoredConfigurations()`
  Gets the AssociationList of `StoredConfigurations`
  `AssociationList`
  `getStoredConfigurations(boolean fGoToServer)`
  Gets the Associationlist of `StoredConfigurations`
  `AssociationList`
  `getValidators()`
  Gets the Association list of `Validators`
  `AssociationList`
  `getValidators(boolean fGoToServer)`
  Gets the Associationlist of `Validators`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedPropertyGroup`
  `StoredConfiguration`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAssociatedPropertyGroup(PropertyGroup inObject)`
  Sets the `AssociatedPropertyGroups` list 0th element to be `inObject`.
  `void`
  `setAssociatedPropertyGroups(AssociationList list)`
  Sets the `AssociatedPropertyGroups` list to be `list`.
  `void`
  `setAssociatedPropertyGroups(AssociationList list, int state)`
  Sets the `AssociatedPropertyGroups` list to be `list`.
  `void`
  `setCustomizers(AssociationList list)`
  Sets the `Customizers` list to be `list`.
  `void`
  `setCustomizers(AssociationList inObjects, int state)`
  Sets the entire Customizers list to match the passed in AssociationList, sets the state of the Customizers
  `void`
  `setEditors(AssociationList list)`
  Sets the `Editors` list to be `list`.
  `void`
  `setEditors(AssociationList inObjects, int state)`
  Sets the entire Editors list to match the passed in AssociationList, sets the state of the Editors
  `void`
  `setIsExpert(int inIsExpert)`
  Sets the `IsExpert` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsExpert(int inIsExpert, int state)`
  Sets the `IsExpert` Metadata State.
  `void`
  `setIsExpert(String inIsExpert)`
  Sets the `IsExpert` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsExpert(String inIsExpert, int state)`
  Sets the `IsExpert` value and Metadata State.
  `void`
  `setIsExpertState(int state)`
  Sets the Metadata State of `IsExpert`.
  `void`
  `setIsLinked(int inIsLinked)`
  Sets the `IsLinked` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsLinked(int inIsLinked, int state)`
  Sets the `IsLinked` Metadata State.
  `void`
  `setIsLinked(String inIsLinked)`
  Sets the `IsLinked` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsLinked(String inIsLinked, int state)`
  Sets the `IsLinked` value and Metadata State.
  `void`
  `setIsLinkedState(int state)`
  Sets the Metadata State of `IsLinked`.
  `void`
  `setIsRequired(int inIsRequired)`
  Sets the `IsRequired` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsRequired(int inIsRequired, int state)`
  Sets the `IsRequired` Metadata State.
  `void`
  `setIsRequired(String inIsRequired)`
  Sets the `IsRequired` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsRequired(String inIsRequired, int state)`
  Sets the `IsRequired` value and Metadata State.
  `void`
  `setIsRequiredState(int state)`
  Sets the Metadata State of `IsRequired`.
  `void`
  `setIsUpdateable(int inIsUpdateable)`
  Sets the `IsUpdateable` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsUpdateable(int inIsUpdateable, int state)`
  Sets the `IsUpdateable` Metadata State.
  `void`
  `setIsUpdateable(String inIsUpdateable)`
  Sets the `IsUpdateable` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsUpdateable(String inIsUpdateable, int state)`
  Sets the `IsUpdateable` value and Metadata State.
  `void`
  `setIsUpdateableState(int state)`
  Sets the Metadata State of `IsUpdateable`.
  `void`
  `setIsVisible(int inIsVisible)`
  Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsVisible(int inIsVisible, int state)`
  Sets the `IsVisible` Metadata State.
  `void`
  `setIsVisible(String inIsVisible)`
  Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIsVisible(String inIsVisible, int state)`
  Sets the `IsVisible` value and Metadata State.
  `void`
  `setIsVisibleState(int state)`
  Sets the Metadata State of `IsVisible`.
  `void`
  `setStoredConfiguration(Text inObject)`
  Sets the `StoredConfigurations` list 0th element to be `inObject`.
  `void`
  `setStoredConfigurations(AssociationList list)`
  Sets the `StoredConfigurations` list to be `list`.
  `void`
  `setStoredConfigurations(AssociationList list, int state)`
  Sets the `StoredConfigurations` list to be `list`.
  `void`
  `setValidators(AssociationList list)`
  Sets the `Validators` list to be `list`.
  `void`
  `setValidators(AssociationList inObjects, int state)`
  Sets the entire Validators list to match the passed in AssociationList, sets the state of the Validators

  ### Methods inherited from interface com.sas.metadata.remote.LocalizedType

  `getResources, getResources, setResources, setResources`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_ISVISIBLE_NAME

    static final String ATTRIBUTE_ISVISIBLE_NAME
    Constant used for the name of the IsVisible attribute.

    IsVisible: Should this property be displayed in a UI?

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ISUPDATEABLE_NAME

    static final String ATTRIBUTE_ISUPDATEABLE_NAME
    Constant used for the name of the IsUpdateable attribute.

    IsUpdateable: Can this property be updated?

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ISEXPERT_NAME

    static final String ATTRIBUTE_ISEXPERT_NAME
    Constant used for the name of the IsExpert attribute.

    IsExpert: Should the property be available only to expert users?

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ISREQUIRED_NAME

    static final String ATTRIBUTE_ISREQUIRED_NAME
    Constant used for the name of the IsRequired attribute.

    IsRequired: Is this parameter required?

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ISLINKED_NAME

    static final String ATTRIBUTE_ISLINKED_NAME
    Constant used for the name of the IsLinked attribute.

    IsLinked: IsLinked

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDPROPERTYGROUP_NAME

    static final String ASSOCIATION_ASSOCIATEDPROPERTYGROUP_NAME
    Constant used for the name of the AssociatedPropertyGroup association.

    AssociatedPropertyGroup: The group that contains these properties.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_STOREDCONFIGURATION_NAME

    static final String ASSOCIATION_STOREDCONFIGURATION_NAME
    Constant used for the name of the StoredConfiguration association.

    StoredConfiguration: The configuration information for this object.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_CUSTOMIZERS_NAME

    static final String ASSOCIATION_CUSTOMIZERS_NAME
    Constant used for the name of the Customizers association.

    Customizers: The programs used to customize this object. A customizer is a standalone editor used to customize or edit a value. It does not reside inside a UI element as an editor does, but defines it's own window. If none exists on the entity, the customizer of the property type is returned.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_EDITORS_NAME

    static final String ASSOCIATION_EDITORS_NAME
    Constant used for the name of the Editors association.

    Editors: The programs that can edit this property. The editor is a component that can be placed inside a UI container, such as a property sheet, and that edits the property value.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_VALIDATORS_NAME

    static final String ASSOCIATION_VALIDATORS_NAME
    Constant used for the name of the Validators association.

    Validators: The programs that can validate the value of this property.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `LocalizedType`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `AssociatedPropertyGroup`
    `StoredConfiguration`
    Specified by:
      `initializePredObjects` in interface `LocalizedType`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsVisible

    int getIsVisible() throws RemoteException
    Gets the `int` value of `IsVisible`
    Returns:
      The `IsVisible`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsVisibleState

    int getIsVisibleState() throws RemoteException
    Gets the Metadata State of `IsVisible`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsUpdateable

    int getIsUpdateable() throws RemoteException
    Gets the `int` value of `IsUpdateable`
    Returns:
      The `IsUpdateable`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsUpdateableState

    int getIsUpdateableState() throws RemoteException
    Gets the Metadata State of `IsUpdateable`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsExpert

    int getIsExpert() throws RemoteException
    Gets the `int` value of `IsExpert`
    Returns:
      The `IsExpert`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsExpertState

    int getIsExpertState() throws RemoteException
    Gets the Metadata State of `IsExpert`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsRequired

    int getIsRequired() throws RemoteException
    Gets the `int` value of `IsRequired`
    Returns:
      The `IsRequired`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsRequiredState

    int getIsRequiredState() throws RemoteException
    Gets the Metadata State of `IsRequired`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsLinked

    int getIsLinked() throws RemoteException
    Gets the `int` value of `IsLinked`
    Returns:
      The `IsLinked`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIsLinkedState

    int getIsLinkedState() throws RemoteException
    Gets the Metadata State of `IsLinked`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAssociatedPropertyGroups

    AssociationList getAssociatedPropertyGroups() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedPropertyGroups`
    Returns:
      Returns the AssociationList of `AssociatedPropertyGroups` which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedPropertyGroup

    PropertyGroup getAssociatedPropertyGroup() throws RemoteException, MdException
    Gets the `PropertyGroup` for `AssociatedPropertyGroup`
    Returns:
      The `PropertyGroup` ( `null` if not set) of `AssociatedPropertyGroup`which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getStoredConfigurations

    AssociationList getStoredConfigurations() throws RemoteException, MdException
    Gets the AssociationList of `StoredConfigurations`
    Returns:
      Returns the AssociationList of `StoredConfigurations` which can be of type:
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getStoredConfiguration

    Text getStoredConfiguration() throws RemoteException, MdException
    Gets the `Text` for `StoredConfiguration`
    Returns:
      The `Text` ( `null` if not set) of `StoredConfiguration`which can be of type:
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCustomizers

    AssociationList getCustomizers() throws RemoteException, MdException
    Gets the Association list of `Customizers`
    Returns:
      The AssociationList of `Customizers` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEditors

    AssociationList getEditors() throws RemoteException, MdException
    Gets the Association list of `Editors`
    Returns:
      The AssociationList of `Editors` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getValidators

    AssociationList getValidators() throws RemoteException, MdException
    Gets the Association list of `Validators`
    Returns:
      The AssociationList of `Validators` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedPropertyGroups

    AssociationList getAssociatedPropertyGroups(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedPropertyGroups`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedPropertyGroups` which can be of type:
      PropertyGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getStoredConfigurations

    AssociationList getStoredConfigurations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `StoredConfigurations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `StoredConfigurations` which can be of type:
      Text
      TextStore
      SASCatalogEntry
      File
      ArchiveFile
      ArchiveEntry
      Document
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCustomizers

    AssociationList getCustomizers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Customizers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Customizers` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEditors

    AssociationList getEditors(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Editors`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Editors` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getValidators

    AssociationList getValidators(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Validators`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Validators` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setIsVisible

    void setIsVisible(int inIsVisible) throws RemoteException
    Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsVisible` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisible

    void setIsVisible(int inIsVisible, int state) throws RemoteException
    Sets the `IsVisible` Metadata State.
    Parameters:
      `inIsVisible` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisible

    void setIsVisible(String inIsVisible) throws RemoteException
    Sets the `IsVisible` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsVisible` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisible

    void setIsVisible(String inIsVisible, int state) throws RemoteException
    Sets the `IsVisible` value and Metadata State.
    Parameters:
      `inIsVisible` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsVisibleState

    void setIsVisibleState(int state) throws RemoteException
    Sets the Metadata State of `IsVisible`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsUpdateable

    void setIsUpdateable(int inIsUpdateable) throws RemoteException
    Sets the `IsUpdateable` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsUpdateable` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsUpdateable

    void setIsUpdateable(int inIsUpdateable, int state) throws RemoteException
    Sets the `IsUpdateable` Metadata State.
    Parameters:
      `inIsUpdateable` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsUpdateable

    void setIsUpdateable(String inIsUpdateable) throws RemoteException
    Sets the `IsUpdateable` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsUpdateable` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsUpdateable

    void setIsUpdateable(String inIsUpdateable, int state) throws RemoteException
    Sets the `IsUpdateable` value and Metadata State.
    Parameters:
      `inIsUpdateable` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsUpdateableState

    void setIsUpdateableState(int state) throws RemoteException
    Sets the Metadata State of `IsUpdateable`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsExpert

    void setIsExpert(int inIsExpert) throws RemoteException
    Sets the `IsExpert` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsExpert` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsExpert

    void setIsExpert(int inIsExpert, int state) throws RemoteException
    Sets the `IsExpert` Metadata State.
    Parameters:
      `inIsExpert` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsExpert

    void setIsExpert(String inIsExpert) throws RemoteException
    Sets the `IsExpert` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsExpert` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsExpert

    void setIsExpert(String inIsExpert, int state) throws RemoteException
    Sets the `IsExpert` value and Metadata State.
    Parameters:
      `inIsExpert` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsExpertState

    void setIsExpertState(int state) throws RemoteException
    Sets the Metadata State of `IsExpert`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsRequired

    void setIsRequired(int inIsRequired) throws RemoteException
    Sets the `IsRequired` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsRequired` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsRequired

    void setIsRequired(int inIsRequired, int state) throws RemoteException
    Sets the `IsRequired` Metadata State.
    Parameters:
      `inIsRequired` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsRequired

    void setIsRequired(String inIsRequired) throws RemoteException
    Sets the `IsRequired` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsRequired` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsRequired

    void setIsRequired(String inIsRequired, int state) throws RemoteException
    Sets the `IsRequired` value and Metadata State.
    Parameters:
      `inIsRequired` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsRequiredState

    void setIsRequiredState(int state) throws RemoteException
    Sets the Metadata State of `IsRequired`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsLinked

    void setIsLinked(int inIsLinked) throws RemoteException
    Sets the `IsLinked` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsLinked` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsLinked

    void setIsLinked(int inIsLinked, int state) throws RemoteException
    Sets the `IsLinked` Metadata State.
    Parameters:
      `inIsLinked` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsLinked

    void setIsLinked(String inIsLinked) throws RemoteException
    Sets the `IsLinked` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIsLinked` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsLinked

    void setIsLinked(String inIsLinked, int state) throws RemoteException
    Sets the `IsLinked` value and Metadata State.
    Parameters:
      `inIsLinked` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIsLinkedState

    void setIsLinkedState(int state) throws RemoteException
    Sets the Metadata State of `IsLinked`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedPropertyGroups

    void setAssociatedPropertyGroups(AssociationList list) throws RemoteException
    Sets the `AssociatedPropertyGroups` list to be `list`. Object of which can be of type:
    PropertyGroup
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedPropertyGroups

    void setAssociatedPropertyGroups(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedPropertyGroups` list to be `list`. Object of which can be of type:
    PropertyGroup
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedPropertyGroup

    void setAssociatedPropertyGroup(PropertyGroup inObject) throws RemoteException
    Sets the `AssociatedPropertyGroups` list 0th element to be `inObject`.
    Parameters:
      `inObject` - PropertyGroup
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStoredConfigurations

    void setStoredConfigurations(AssociationList list) throws RemoteException
    Sets the `StoredConfigurations` list to be `list`. Object of which can be of type:
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStoredConfigurations

    void setStoredConfigurations(AssociationList list, int state) throws RemoteException
    Sets the `StoredConfigurations` list to be `list`. Object of which can be of type:
    Text
    TextStore
    SASCatalogEntry
    File
    ArchiveFile
    ArchiveEntry
    Document
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setStoredConfiguration

    void setStoredConfiguration(Text inObject) throws RemoteException
    Sets the `StoredConfigurations` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Text
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCustomizers

    void setCustomizers(AssociationList list) throws RemoteException
    Sets the `Customizers` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCustomizers

    void setCustomizers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Customizers list to match the passed in AssociationList, sets the state of the Customizers
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEditors

    void setEditors(AssociationList list) throws RemoteException
    Sets the `Editors` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEditors

    void setEditors(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Editors list to match the passed in AssociationList, sets the state of the Editors
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValidators

    void setValidators(AssociationList list) throws RemoteException
    Sets the `Validators` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValidators

    void setValidators(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Validators list to match the passed in AssociationList, sets the state of the Validators
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.